#include <atomic>
#include <iomanip>
#include <cmath>
#include <vector>
#include <iostream>
#include <chrono>
#define DEBUG
#ifdef DEBUG
#include <thread>
#endif
#ifdef SEM
#include <semaphore.h>
#endif
#ifdef _WIN32
#include <handleapi.h>
#include <processthreadsapi.h>
#include <synchapi.h>
#include <libloaderapi.h>
#include <errhandlingapi.h>
#ifdef SPIN
bool canwrite(true);
#endif
#else
#include <csignal>
#include <unistd.h>
#include <dlfcn.h>
void (*changeprior)(pthread_t);
#ifdef SEM
#include <semaphore.h>
#endif
#endif
#ifdef _WIN32
#define pthread_t HANDLE
#define pthread_cancel(T) TerminateThread(T, 0)
#ifdef LINK
extern "C"
__declspec(dllimport) void CALLBACK interactive(HANDLE);
#else
typedef float (*exported)(pthread_t);
#endif
#endif
#define neediters 10000
float f(float);
#define displayinfo cout<<"Threads\tTime (ns)\n";for(unsigned int i=0;i<cthreads-1;i++)cout<<i+1<<"\t"<<t[i]<<endl;
#define num_threads 12
using namespace std;

std::atomic<bool> stopThreads(false);
float trapezoidal(float a, float b, unsigned int n) {
    float sum = 0;
    float h = (b - a) / n;
    sum += (f(a) + f(b)) / 2;
    for (int i = 1; i < n; i++) {
        while(stopThreads){}
        float x = a + i * h;
        sum += f(x);
    }
#ifdef DEBUG
std::this_thread::sleep_for(std::chrono::seconds(1));
#endif
    return sum * h;
}
#ifndef FIXED
vector<unsigned int> t;
#endif
vector<pthread_t> threads;
unsigned short cthreads;
float result;
#ifdef _WIN32
HANDLE hEvent;
#endif
typedef struct ThreadParams {
    float start;
    float end;
    float* result;
    unsigned int n;
} th_param;

#ifdef SEM
sem_t semaphore;
#endif
#ifdef BAR
pthread_barrier_t barrier;
#endif

#ifdef _WIN32
DWORD WINAPI
#else
void*
#endif
ThreadFunction(
    #ifdef _WIN32
    LPVOID lpParam
    #else
    void* args
    #endif
    ){
#ifdef _WIN32
  th_param* args = reinterpret_cast<th_param*>(lpParam);
    float local_result = trapezoidal(args->start, args->end, args->n);
#else
    float local_result = trapezoidal(((th_param*)args)->start, ((th_param*)args)->end, ((th_param*)args)->n);
#endif
#ifdef EVENT
            WaitForSingleObject(hEvent, 0xFFFFFFFF);
#endif
#ifdef SPIN
            while (!canwrite){}canwrite=false;
#endif
#ifdef SEM
            sem_wait(&semaphore);
#endif
            result+=local_result;
#ifdef EVENT
            SetEvent(hEvent);
#endif
#ifdef SPIN
            canwrite=true;
#endif
#ifdef SEM
            sem_post(&semaphore);
#endif
#ifndef _WIN32
            delete (th_param*)args;
#endif
    return 0;
}
void* displayMenu(void* args) {
    while (true) {
        cin.get();
        stopThreads = true;
        cout << cthreads << " threads were interrupted." << endl;
        cout << "Menu:"<<std::endl<<"1. Resume"<<endl<<"2. Change priority for thread..."<<endl<<"3. (Unreccomend) deattch thread and continue... "<<endl<<"0. Exit program"<<endl<<"Choose an option: ";
        char option;
        cin >> option;
        if (option == '1') {
            stopThreads = false;
            cin.get();
        } else if (option == '2') {
            cout << "Select thread to change priority: ";
            unsigned short thread;
            cin >> thread;
#ifdef _WIN32
#ifdef LINK
            interactive(threads[thread - 1]);
#else
            HMODULE hLib = LoadLibrary("libDynamicLib.dll");
              if (hLib) {
                  exported changeprior = (exported)GetProcAddress(hLib, "interactive");
                  if (changeprior) changeprior(threads[thread - 1]);
                  else std::cout<<"Error loading dynamic function: "<<GetLastError()<<endl;
                     FreeLibrary(hLib);
                 }
              else {
                  std::cout<<"Error loading library: "<<GetLastError()<<endl;
              }
#endif
#else
#ifdef LINK
       changeprior(threads[thread - 1]);
#else
       void *hDll;
       hDll=dlopen("libDynamicLib.so", RTLD_NOW);
       *(void **)(&changeprior) = dlsym(hDll, "interactive");
       if (changeprior) changeprior(threads[thread - 1]);
       else std::cout<<"Error loading dynamic function: "<<dlerror()<<endl;
       dlclose(hDll);
#endif
#endif
        } else if (option == '0') {
            displayinfo;
            exit(0);
        }
#ifndef _WIN32
        else if (option == '3') {
                    cout << "Select thread to deatach: ";
                    unsigned short thread;
                    cin >> thread;
                    pthread_detach(threads[thread - 1]);
                    cout << "Detached thread " << threads[thread - 1] << endl;
                    if (pthread_kill(threads[thread - 1], 0) == ESRCH)
                        cout << "Thread is dead after deatach..." << endl;
                    else
                        cout << "Thread is still alive after deatach..." << endl;
                    stopThreads = false;
                    cin.get();
          }
#endif
    }
}

int main() {
#ifdef EVENT
    HANDLE hEvent=CreateEvent(NULL,TRUE,TRUE,NULL);
#elif defined(SEM)
    sem_init(&semaphore, 0, 1);
#endif
    pthread_t hInput
    #ifdef _WIN32
        = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)displayMenu, NULL, 0, NULL);
#else
    ;pthread_create(&hInput,NULL,displayMenu,NULL);
#endif
#ifdef FIXED
#define cthreads num_threads
#else
    for (cthreads = 1; cthreads <= num_threads; cthreads++)
#endif
      {
        float per = 100.0 / cthreads;
        float current = 0;
        result = 0;
        threads.clear();
        auto start = chrono::high_resolution_clock::now();

        for (unsigned char i = 0; i < cthreads; i++) {
            float start = current;
            current += per;
            unsigned int n=neediters/cthreads;
            th_param* params = new th_param{start, current, &result, n};

            pthread_t hThread
                #ifdef _WIN32
                = CreateThread(
                NULL, 0, ThreadFunction, params, 0, NULL);
#else
            ;pthread_create(&hThread, 0, ThreadFunction, params);
#endif
            if (hThread) {
                threads.push_back(hThread);
            } else {
                cerr << "Failed to create thread " << i + 1 << endl;
                delete params;
            }
        }

        for (pthread_t hThread : threads) {
#ifdef _WIN32
            WaitForSingleObject(hThread, 0xFFFFFFFF);
            CloseHandle(hThread);
#else
            pthread_join(hThread, 0);
#endif
        }
#ifdef FIXED
        cout<<"Took "<<chrono::duration_cast<chrono::nanoseconds>(chrono::high_resolution_clock::now() - start).count()<<" nanoseconds for "<<cthreads<<" threads"<<endl;
#else
        t.push_back(chrono::duration_cast<chrono::nanoseconds>(chrono::high_resolution_clock::now() - start).count());
#endif
        if (result<-194&&result>-195)cout<<"Verification passed for "<<cthreads<<"\tthreads... result: "<<setprecision(5)<<result<<endl;
                else {cout<<"Verification failed for "<<cthreads<<" threads!!!"<<endl<<"Got "<<result<<endl;pthread_cancel(hInput);return 1;}
        #ifdef BAR
                pthread_barrier_destroy(&barrier);
        #endif
    }
    pthread_cancel(hInput);
    displayinfo;

#ifdef EVENT
    CloseHandle(hEvent);
#endif
    return 0;
}
